Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ParameterView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ParameterView.cs	(revision 2663)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ParameterView.cs	(revision 2664)
@@ -33,8 +33,6 @@
   /// The visual representation of a <see cref="Parameter"/>.
   /// </summary>
-  [Content(typeof(Parameter), true)]
-  public partial class ParameterView : ParameterBaseView {
-    private TypeSelectorDialog typeSelectorDialog;
-
+  [Content(typeof(IParameter), true)]
+  public partial class ParameterView : NamedItemView {
     /// <summary>
     /// Gets or sets the variable to represent visually.
@@ -42,6 +40,6 @@
     /// <remarks>Uses property <see cref="ViewBase.Item"/> of base class <see cref="ViewBase"/>.
     /// No own data storage present.</remarks>
-    public new Parameter Parameter {
-      get { return (Parameter)Item; }
+    public IParameter Parameter {
+      get { return (IParameter)Item; }
       set { base.Item = value; }
     }
@@ -59,27 +57,7 @@
     /// <remarks>Calls <see cref="VariableView()"/>.</remarks>
     /// <param name="variable">The variable to represent visually.</param>
-    public ParameterView(Parameter parameter)
+    public ParameterView(IParameter parameter)
       : this() {
       Parameter = parameter;
-    }
-
-    /// <summary>
-    /// Removes the eventhandlers from the underlying <see cref="IVariable"/>.
-    /// </summary>
-    /// <remarks>Calls <see cref="ViewBase.RemoveItemEvents"/> of base class <see cref="ViewBase"/>.</remarks>
-    protected override void DeregisterObjectEvents() {
-      Parameter.ActualNameChanged -= new EventHandler(Parameter_ActualNameChanged);
-      Parameter.ValueChanged -= new EventHandler(Parameter_ValueChanged);
-      base.DeregisterObjectEvents();
-    }
-
-    /// <summary>
-    /// Adds eventhandlers to the underlying <see cref="IVariable"/>.
-    /// </summary>
-    /// <remarks>Calls <see cref="ViewBase.AddItemEvents"/> of base class <see cref="ViewBase"/>.</remarks>
-    protected override void RegisterObjectEvents() {
-      base.RegisterObjectEvents();
-      Parameter.ActualNameChanged += new EventHandler(Parameter_ActualNameChanged);
-      Parameter.ValueChanged += new EventHandler(Parameter_ValueChanged);
     }
 
@@ -88,67 +66,10 @@
       if (Parameter == null) {
         Caption = "Parameter";
-        actualNameTextBox.Text = "-";
-        actualNameTextBox.Enabled = false;
-        setValueButton.Enabled = false;
-        clearValueButton.Enabled = false;
-        valueGroupBox.Enabled = false;
-        viewHost.Object = null;
+        dataTypeTextBox.Text = "-";
+        dataTypeTextBox.Enabled = false;
       } else {
         Caption = Parameter.Name + " (" + Parameter.GetType().Name + ")";
-        actualNameTextBox.Text = Parameter.ActualName;
-        actualNameTextBox.Enabled = Parameter.Value == null;
-        setValueButton.Enabled = Parameter.Value == null;
-        clearValueButton.Enabled = Parameter.Value != null;
-        valueGroupBox.Enabled = true;
-        viewHost.Object = Parameter.Value;
-      }
-    }
-
-    private void Parameter_ActualNameChanged(object sender, EventArgs e) {
-      if (InvokeRequired)
-        Invoke(new EventHandler(Parameter_ActualNameChanged), sender, e);
-      else
-        actualNameTextBox.Text = Parameter.ActualName;
-    }
-    private void Parameter_ValueChanged(object sender, EventArgs e) {
-      if (InvokeRequired)
-        Invoke(new EventHandler(Parameter_ValueChanged), sender, e);
-      else {
-        actualNameTextBox.Enabled = Parameter.Value == null;
-        setValueButton.Enabled = Parameter.Value == null;
-        clearValueButton.Enabled = Parameter.Value != null;
-        viewHost.Object = Parameter.Value;
-      }
-    }
-
-    private void actualNameTextBox_Validated(object sender, EventArgs e) {
-      Parameter.ActualName = actualNameTextBox.Text;
-    }
-    private void setValueButton_Click(object sender, EventArgs e) {
-      if (typeSelectorDialog == null) {
-        typeSelectorDialog = new TypeSelectorDialog();
-        typeSelectorDialog.Caption = "Select Value Type";
-      }
-      typeSelectorDialog.TypeSelector.Configure(Parameter.DataType, false, false);
-      if (typeSelectorDialog.ShowDialog(this) == DialogResult.OK)
-        Parameter.Value = (IItem)typeSelectorDialog.TypeSelector.CreateInstanceOfSelectedType();
-    }
-    private void clearValueButton_Click(object sender, EventArgs e) {
-      Parameter.Value = null;
-    }
-    private void valuePanel_DragEnterOver(object sender, DragEventArgs e) {
-      e.Effect = DragDropEffects.None;
-      Type type = e.Data.GetData("Type") as Type;
-      if ((type != null) && (Parameter.DataType.IsAssignableFrom(type))) {
-        if ((e.KeyState & 8) == 8) e.Effect = DragDropEffects.Copy;  // CTRL key
-        else if ((e.KeyState & 32) == 32) e.Effect = DragDropEffects.Move;  // ALT key
-        else e.Effect = DragDropEffects.Link;
-      }
-    }
-    private void valuePanel_DragDrop(object sender, DragEventArgs e) {
-      if (e.Effect != DragDropEffects.None) {
-        IItem item = e.Data.GetData("Value") as IItem;
-        if ((e.Effect & DragDropEffects.Copy) == DragDropEffects.Copy) item = (IItem)item.Clone();
-        Parameter.Value = item;
+        dataTypeTextBox.Text = Parameter.DataType.Name;
+        dataTypeTextBox.Enabled = true;
       }
     }
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ScopeView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ScopeView.cs	(revision 2663)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ScopeView.cs	(revision 2664)
@@ -37,5 +37,5 @@
   /// </summary>
   [Content(typeof(Scope), true)]
-  public partial class ScopeView : ItemViewBase {
+  public partial class ScopeView : ItemView {
     private Dictionary<Scope, TreeNode> scopeNodeTable;
     private Dictionary<ScopeList, Scope> subScopesScopeTable;
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/VariableView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/VariableView.cs	(revision 2663)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/VariableView.cs	(revision 2664)
@@ -34,5 +34,5 @@
   /// </summary>
   [Content(typeof(Variable), true)]
-  public partial class VariableView : NamedItemBaseView {
+  public partial class VariableView : NamedItemView {
     private TypeSelectorDialog typeSelectorDialog;
 
Index: /trunk/sources/HeuristicLab.Core/3.3/DeepCloneable.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/DeepCloneable.cs	(revision 2664)
+++ /trunk/sources/HeuristicLab.Core/3.3/DeepCloneable.cs	(revision 2664)
@@ -0,0 +1,59 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Xml;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Core {
+  /// <summary>
+  /// Represents a base class for all deeply cloneable objects.
+  /// </summary>
+  [EmptyStorableClass]
+  public abstract class DeepCloneable : IDeepCloneable {
+    /// <summary>
+    /// Creates a deep clone of this instance.
+    /// </summary>
+    /// <remarks>
+    /// This method is the entry point for creating a deep clone of a whole object graph.
+    /// </remarks>
+    /// <returns>A clone of this instance.</returns>
+    public object Clone() {
+      return Clone(new Cloner());
+    }
+
+    /// <summary>
+    /// Creates a deep clone of this instance.
+    /// </summary>
+    /// <remarks>This method should not be called directly. It is used for creating clones of
+    /// objects which are contained in the object that is currently cloned.</remarks>
+    /// <param name="cloner">The cloner which is responsible for keeping track of all already
+    /// cloned objects.</param>
+    /// <returns>A clone of this instance.</returns>
+    public virtual IDeepCloneable Clone(Cloner cloner) {
+      DeepCloneable clone = (DeepCloneable)Activator.CreateInstance(this.GetType());
+      cloner.RegisterClonedObject(this, clone);
+      return clone;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Core/3.3/Engine.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Engine.cs	(revision 2664)
+++ /trunk/sources/HeuristicLab.Core/3.3/Engine.cs	(revision 2664)
@@ -0,0 +1,293 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Xml;
+using System.Threading;
+using System.Drawing;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Core {
+  /// <summary>
+  /// Base class to represent an engine, which is an interpreter, holding the code, the data and 
+  /// the actual state, which is the runtime stack and a pointer onto the next operation. It represents
+  /// one execution and can handle parallel executions.
+  /// </summary>
+  [Item("Engine", "A base class for engines.")]
+  public abstract class Engine : Item, IEngine {
+    public override Image ItemImage {
+      get { return HeuristicLab.Common.Resources.VS2008ImageLibrary.Event; }
+    }
+
+    /// <summary>
+    /// Field of the current instance that represent the operator graph.
+    /// </summary>
+    private OperatorGraph operatorGraph;
+    /// <summary>
+    /// Gets the current operator graph.
+    /// </summary>
+    [Storable]
+    public OperatorGraph OperatorGraph {
+      get { return operatorGraph; }
+      set {
+        if (value == null) throw new ArgumentNullException();
+        if (value != operatorGraph) {
+          if (operatorGraph != null) operatorGraph.InitialOperatorChanged -= new EventHandler(operatorGraph_InitialOperatorChanged);
+          operatorGraph = value;
+          if (operatorGraph != null) operatorGraph.InitialOperatorChanged += new EventHandler(operatorGraph_InitialOperatorChanged);
+          OnOperatorGraphChanged();
+          Initialize();
+        }
+      }
+    }
+
+    /// <summary>
+    /// Field of the current instance that represent the global scope.
+    /// </summary>
+    [Storable]
+    private Scope globalScope;
+    /// <summary>
+    /// Gets the current global scope.
+    /// </summary>
+    public Scope GlobalScope {
+      get { return globalScope; }
+    }
+
+    [Storable]
+    private TimeSpan executionTime;
+    /// <summary>
+    /// Gets or sets the execution time.
+    /// </summary>
+    /// <remarks>Calls <see cref="OnExecutionTimeChanged"/> in the setter.</remarks>
+    public TimeSpan ExecutionTime {
+      get { return executionTime; }
+      protected set {
+        executionTime = value;
+        OnExecutionTimeChanged();
+      }
+    }
+
+    /// <summary>
+    /// Field of the current instance that represent the execution stack.
+    /// </summary>
+    [Storable]
+    private Stack<ExecutionContext> executionStack;
+    /// <summary>
+    /// Gets the current execution stack.
+    /// </summary>
+    protected Stack<ExecutionContext> ExecutionStack {
+      get { return executionStack; }
+    }
+
+    /// <summary>
+    /// Flag of the current instance whether it is currently running.
+    /// </summary>
+    private bool running;
+    /// <summary>
+    /// Gets information whether the instance is currently running.
+    /// </summary>
+    public bool Running {
+      get { return running; }
+    }
+
+    /// <summary>
+    /// Flag of the current instance whether it is canceled.
+    /// </summary>
+    private bool canceled;
+    /// <summary>
+    /// Gets information whether the instance is currently canceled.
+    /// </summary>
+    protected bool Canceled {
+      get { return canceled; }
+    }
+    /// <summary>
+    /// Gets information whether the instance has already terminated.
+    /// </summary>
+    public bool Finished {
+      get { return executionStack.Count == 0; }
+    }
+
+    /// <summary>
+    /// Initializes a new instance of <see cref="EngineBase"/> with a new global scope.
+    /// </summary>
+    /// <remarks>Calls <see cref="Reset"/>.</remarks>
+    protected Engine() {
+      globalScope = new Scope("Global");
+      executionStack = new Stack<ExecutionContext>();
+      OperatorGraph = new OperatorGraph();
+    }
+
+    /// <summary>
+    /// Clones the current instance (deep clone).
+    /// </summary>
+    /// <remarks>Deep clone through <see cref="cloner.Clone"/> method of helper class 
+    /// <see cref="Auxiliary"/>.</remarks>
+    /// <param name="clonedObjects">Dictionary of all already clone objects. (Needed to avoid cycles.)</param>
+    /// <returns>The cloned object as <see cref="EngineBase"/>.</returns>
+    public override IDeepCloneable Clone(Cloner cloner) {
+      Engine clone = (Engine)base.Clone(cloner);
+      clone.OperatorGraph = (OperatorGraph)cloner.Clone(operatorGraph);
+      clone.globalScope = (Scope)cloner.Clone(globalScope);
+      clone.executionTime = executionTime;
+      ExecutionContext[] contexts = executionStack.ToArray();
+      for (int i = contexts.Length - 1; i >= 0; i--)
+        clone.executionStack.Push((ExecutionContext)cloner.Clone(contexts[i]));
+      clone.running = running;
+      clone.canceled = canceled;
+      return clone;
+    }
+
+    /// <inheritdoc/>
+    /// <remarks>Sets <c>myCanceled</c> and <c>myRunning</c> to <c>false</c>. The global scope is cleared,
+    /// the execution time is reseted, the execution stack is cleared and a new <see cref="AtomicOperation"/>
+    /// with the initial operator is added. <br/>
+    /// Calls <see cref="OnInitialized"/>.</remarks>
+    public void Initialize() {
+      canceled = false;
+      running = false;
+      GlobalScope.Clear();
+      ExecutionTime = new TimeSpan();
+      executionStack.Clear();
+      if (OperatorGraph.InitialOperator != null)
+        executionStack.Push(new ExecutionContext(null, OperatorGraph.InitialOperator, GlobalScope));
+      OnInitialized();
+    }
+    /// <inheritdoc/>
+    /// <remarks>Calls <see cref="ThreadPool.QueueUserWorkItem(System.Threading.WaitCallback, object)"/> 
+    /// of class <see cref="ThreadPool"/>.</remarks>
+    public void Start() {
+      running = true;
+      canceled = false;
+      ThreadPool.QueueUserWorkItem(new WaitCallback(Run), null);
+    }
+    /// <inheritdoc/>
+    /// <remarks>Calls <see cref="ThreadPool.QueueUserWorkItem(System.Threading.WaitCallback, object)"/> 
+    /// of class <see cref="ThreadPool"/>.</remarks>
+    public void Step() {
+      running = true;
+      canceled = false;
+      ThreadPool.QueueUserWorkItem(new WaitCallback(RunStep), null);
+    }
+    /// <inheritdoc/>
+    /// <remarks>Sets the protected flag <c>myCanceled</c> to <c>true</c>.</remarks>
+    public virtual void Stop() {
+      canceled = true;
+    }
+
+    private void Run(object state) {
+      OnStarted();
+      DateTime start = DateTime.Now;
+      DateTime end;
+      while ((!Canceled) && (!Finished)) {
+        ProcessNextOperator();
+        end = DateTime.Now;
+        ExecutionTime += end - start;
+        start = end;
+      }
+      ExecutionTime += DateTime.Now - start;
+      running = false;
+      OnStopped();
+    }
+    private void RunStep(object state) {
+      OnStarted();
+      DateTime start = DateTime.Now;
+      if ((!Canceled) && (!Finished))
+        ProcessNextOperator();
+      ExecutionTime += DateTime.Now - start;
+      running = false;
+      OnStopped();
+    }
+
+    /// <summary>
+    /// Performs the next operation.
+    /// </summary>
+    protected abstract void ProcessNextOperator();
+
+    private void operatorGraph_InitialOperatorChanged(object sender, EventArgs e) {
+      Initialize();
+    }
+
+    public event EventHandler OperatorGraphChanged;
+    protected virtual void OnOperatorGraphChanged() {
+      if (OperatorGraphChanged != null)
+        OperatorGraphChanged(this, EventArgs.Empty);
+    }
+    /// <summary>
+    /// Occurs when the execution time changed.
+    /// </summary>
+    public event EventHandler ExecutionTimeChanged;
+    /// <summary>
+    /// Fires a new <c>ExecutionTimeChanged</c> event.
+    /// </summary>
+    protected virtual void OnExecutionTimeChanged() {
+      if (ExecutionTimeChanged != null)
+        ExecutionTimeChanged(this, new EventArgs());
+    }
+    /// <summary>
+    /// Occurs when the execution is initialized.
+    /// </summary>
+    public event EventHandler Initialized;
+    /// <summary>
+    /// Fires a new <c>Initialized</c> event.
+    /// </summary>
+    protected virtual void OnInitialized() {
+      if (Initialized != null)
+        Initialized(this, new EventArgs());
+    }
+    /// <summary>
+    /// Occurs when the execution is executed.
+    /// </summary>
+    public event EventHandler Started;
+    /// <summary>
+    /// Fires a new <c>Started</c> event.
+    /// </summary>
+    protected virtual void OnStarted() {
+      if (Started != null)
+        Started(this, new EventArgs());
+    }
+    /// <summary>
+    /// Occurs when the execution is finished.
+    /// </summary>
+    public event EventHandler Stopped;
+    /// <summary>
+    /// Fires a new <c>Stopped</c> event.
+    /// </summary>
+    protected virtual void OnStopped() {
+      if (Stopped != null)
+        Stopped(this, new EventArgs());
+    }
+    /// <summary>
+    /// Occurs when an exception occured during the execution.
+    /// </summary>
+    public event EventHandler<EventArgs<Exception>> ExceptionOccurred;
+    /// <summary>
+    /// Aborts the execution and fires a new <c>ExceptionOccurred</c> event.
+    /// </summary>
+    /// <param name="exception">The exception that was thrown.</param>
+    protected virtual void OnExceptionOccurred(Exception exception) {
+      if (ExceptionOccurred != null)
+        ExceptionOccurred(this, new EventArgs<Exception>(exception));
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Core/3.3/ExecutionContext.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/ExecutionContext.cs	(revision 2663)
+++ /trunk/sources/HeuristicLab.Core/3.3/ExecutionContext.cs	(revision 2664)
@@ -26,5 +26,5 @@
 
 namespace HeuristicLab.Core {
-  public class ExecutionContext : DeepCloneableBase {
+  public class ExecutionContext : DeepCloneable {
     [Storable]
     private ExecutionContext parent;
Index: /trunk/sources/HeuristicLab.Core/3.3/ExecutionContextCollection.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/ExecutionContextCollection.cs	(revision 2663)
+++ /trunk/sources/HeuristicLab.Core/3.3/ExecutionContextCollection.cs	(revision 2664)
@@ -27,5 +27,5 @@
 
 namespace HeuristicLab.Core {
-  public class ExecutionContextCollection : DeepCloneableBase, IList<ExecutionContext> {
+  public class ExecutionContextCollection : DeepCloneable, IList<ExecutionContext> {
     [Storable]
     private IList<ExecutionContext> contexts;
Index: /trunk/sources/HeuristicLab.Core/3.3/HeuristicLab.Core-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/HeuristicLab.Core-3.3.csproj	(revision 2663)
+++ /trunk/sources/HeuristicLab.Core/3.3/HeuristicLab.Core-3.3.csproj	(revision 2664)
@@ -103,8 +103,12 @@
     <Compile Include="Attributes\CreatableAttribute.cs" />
     <Compile Include="ChangedEventArgs.cs" />
+    <Compile Include="DeepCloneable.cs" />
+    <Compile Include="Engine.cs" />
     <Compile Include="Interfaces\IOperatorParameter.cs" />
+    <Compile Include="Item.cs" />
+    <Compile Include="ItemParameter.cs" />
+    <Compile Include="NamedItem.cs" />
     <Compile Include="OperatorGraph.cs" />
     <Compile Include="OperatorParameter.cs" />
-    <Compile Include="ParameterBase.cs" />
     <Compile Include="Interfaces\IParameter.cs" />
     <Compile Include="OperatorCollection.cs" />
@@ -113,7 +117,4 @@
     <Compile Include="ItemSet.cs" />
     <Compile Include="ItemList.cs" />
-    <Compile Include="EngineBase.cs">
-      <SubType>Code</SubType>
-    </Compile>
     <Compile Include="Interfaces\IEngine.cs">
       <SubType>Code</SubType>
@@ -126,11 +127,8 @@
     <Compile Include="Parameter.cs" />
     <Compile Include="ScopeList.cs" />
-    <Compile Include="DeepCloneableBase.cs" />
     <Compile Include="Interfaces\IDeepCloneable.cs" />
     <Compile Include="NamedItemCollection.cs" />
     <Compile Include="Interfaces\INamedItem.cs" />
-    <Compile Include="NamedItemBase.cs" />
     <Compile Include="Interfaces\IItem.cs" />
-    <Compile Include="ItemBase.cs" />
     <Compile Include="Interfaces\IRandom.cs" />
     <Compile Include="Scope.cs" />
Index: /trunk/sources/HeuristicLab.Core/3.3/Item.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Item.cs	(revision 2664)
+++ /trunk/sources/HeuristicLab.Core/3.3/Item.cs	(revision 2664)
@@ -0,0 +1,66 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Text;
+using System.Xml;
+using System.Drawing;
+using System.Resources;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common.Resources;
+
+namespace HeuristicLab.Core {
+  /// <summary>
+  /// Represents the base class for all basic item types.
+  /// </summary>
+  [EmptyStorableClass]
+  [Item("Item", "Base class for all HeuristicLab items.")]
+  public abstract class Item : DeepCloneable, IItem {
+    public virtual string ItemName {
+      get { return ItemAttribute.GetName(this.GetType()); }
+    }
+    public virtual string ItemDescription {
+      get { return ItemAttribute.GetDescription(this.GetType()); }
+    }
+    public virtual Image ItemImage {
+      get { return VS2008ImageLibrary.Class; }
+    }
+
+    /// <summary>
+    /// Gets the string representation of the current instance.
+    /// </summary>
+    /// <returns>The type name of the current instance.</returns>
+    public override string ToString() {
+      return ItemName;
+    }
+
+    public event ChangedEventHandler Changed;
+    protected void OnChanged() {
+      OnChanged(new ChangedEventArgs());
+    }
+    protected virtual void OnChanged(ChangedEventArgs e) {
+      if ((e.RegisterChangedObject(this)) && (Changed != null))
+          Changed(this, e);
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Core/3.3/ItemParameter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/ItemParameter.cs	(revision 2664)
+++ /trunk/sources/HeuristicLab.Core/3.3/ItemParameter.cs	(revision 2664)
@@ -0,0 +1,153 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Xml;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Core {
+  /// <summary>
+  /// Represents a parameter.
+  /// </summary>
+  [Item("Item Parameter", "A parameter which represents an IItem.")]
+  [Creatable("Test")]
+  public class ItemParameter : Parameter {
+    [Storable]
+    private string actualName;
+    public string ActualName {
+      get { return actualName; }
+      set {
+        if (value == null) throw new ArgumentNullException();
+        if (!actualName.Equals(value)) {
+          actualName = value;
+          OnActualNameChanged();
+        }
+      }
+    }
+
+    private IItem value;
+    [Storable]
+    public IItem Value {
+      get { return this.value; }
+      set {
+        if (value != this.value) {
+          if ((value != null) && (!DataType.IsInstanceOfType(value))) throw new ArgumentException("Static value does not match data type of parameter");
+          if (this.value != null) this.value.Changed -= new ChangedEventHandler(Value_Changed);
+          this.value = value;
+          if (this.value != null) this.value.Changed += new ChangedEventHandler(Value_Changed);
+          OnValueChanged();
+        }
+      }
+    }
+
+    public ItemParameter()
+      : base("Anonymous", null, typeof(IItem)) {
+      actualName = Name;
+      Value = null;
+    }
+    protected ItemParameter(string name, string description, Type dataType)
+      : base(name, description, dataType) {
+      this.actualName = Name;
+      this.Value = null;
+    }
+    public ItemParameter(string name, string description)
+      : base(name, description, typeof(IItem)) {
+      this.actualName = Name;
+      this.Value = null;
+    }
+    public ItemParameter(string name, string description, IItem value)
+      : base(name, description, typeof(IItem)) {
+      this.actualName = Name;
+      this.Value = value;
+    }
+
+    public override IItem GetValue(ExecutionContext context) {
+      if (Value != null) return Value;
+      ExecutionContext parent = context.Parent;
+      IParameter parameter = null;
+
+      while ((parent != null) && (parameter == null)) {
+        parent.Operator.Parameters.TryGetValue(ActualName, out parameter);
+        parent = parent.Parent;
+      }
+
+      if (parameter != null) return parameter.GetValue(context);
+      else return context.Scope.Lookup(ActualName, true).Value;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      ItemParameter clone = (ItemParameter)base.Clone(cloner);
+      clone.actualName = actualName;
+      clone.Value = (IItem)cloner.Clone(value);
+      return clone;
+    }
+
+    public override string ToString() {
+      return string.Format("{0}: {1} ({2})", Name, Value != null ? Value.ToString() : ActualName, DataType.Name);
+    }
+
+    public event EventHandler ActualNameChanged;
+    private void OnActualNameChanged() {
+      if (ActualNameChanged != null)
+        ActualNameChanged(this, new EventArgs());
+      OnChanged();
+    }
+    public event EventHandler ValueChanged;
+    private void OnValueChanged() {
+      if (ValueChanged != null)
+        ValueChanged(this, new EventArgs());
+      OnChanged();
+    }
+
+    private void Value_Changed(object sender, ChangedEventArgs e) {
+      OnChanged(e);
+    }
+  }
+
+  [Item("Parameter<T>", "A generic parameter which represents an instance of type T.")]
+  [EmptyStorableClass]
+  public class ItemParameter<T> : ItemParameter where T : class, IItem {
+    public new T Value {
+      get { return (T)base.Value; }
+      set { base.Value = value; }
+    }
+
+    public ItemParameter()
+      : base("Anonymous", null, typeof(T)) {
+      Value = null;
+    }
+    public ItemParameter(string name, string description)
+      : base(name, description, typeof(T)) {
+      this.Value = null;
+    }
+    public ItemParameter(string name, string description, T value)
+      : base(name, description, typeof(T)) {
+      this.Value = value;
+    }
+
+    public new T GetValue(ExecutionContext context) {
+      return (T)base.GetValue(context);
+    }
+  }
+}
